<template>
  <apexchart
    :options="chartOptions"
    :series="series" />
</template>

<script>
import VueApexCharts from 'vue3-apexcharts'

const conf = config()

export default {
  components: {
    apexchart: VueApexCharts
  },
  data () {
    return {
      series: [],
      chartOptions: {
            colors: ['#f2c037', '#21ba45', '#c10015', '#26a69a'],
            chart: {
                id: "ChartBubbles",
                height: 470,
                type: 'bubble',
                toolbar: {
                  show: false,
                },
            },
            dataLabels: {
                enabled: false
            },
            fill: {
                opacity: 0.8
            },
            noData: { text: "Loading data..." },
            yaxis: { decimalsInFloat: 1 },
            xaxis: {
               type: "datetime",
                labels: {
                   datetimeFormatter: {
                     year: 'yyyy',
                     month: 'MMM \'yy',
                     day: 'dd MMM',
                     hour: 'HH:mm'
                   }
                }
            }
      } 
    }
  },
  created () {
    this.emitter.on('tests.summary.selected', (row) => {
       this.series = []
       fetch(conf.I4C_API_SERVER + "/projects/2/tests/" + row.id)
         .then(response => response.json())
         .then(data => (this.update(data)));
    })
  },

  methods: {
    update (data) {
      let results = {'failed': [],
                     'success': [],
                     'error': [],
                     'skipped': []}

      data.test_results.forEach(function (item) {
         let run = [item.job.started_at, item.execution_time, 10]
         results[item.status].push(run)
    
      })
      let series = []
      const keys = ['failed', 'success', 'error', 'skipped']
      keys.forEach(function (key) {
          series.push({'name': key, 'data': results[key]})
      })
      this.series = series
    }
  }
}
</script>

<style>
/*
div.q-card__section:nth-child(5) > div:nth-child(1) {
 min-height: 337.36px;
 min-width: 100%;
}

div.q-card__section:nth-child(5) {
 padding-left: 0px;
}

#apexchartsChartBubbles {
 width: 100%;
 height: 314.907px;
 position: absolute !important;
 top: 0px;
 bottom: 0px;
}
*/
</style>
